#!/usr/bin/perl
#use strict;
use Getopt::Std;
use IO::Socket;
use Net::hostent; 

my $servsock;
my $own;
my %options;
getopts('s:o:n:',\%options);


    if ((!(defined $options{s})) || (!(defined $options{o})) ){
	print STDERR "Specify the Timbl socket no. with \'-s socket\' and the own socket with '-o socket' \n";
	exit;
    }

if (defined $ENV{'SENSELEARNERHOME'}){
	$DEFAULT_DIR=$ENV{'SENSELEARNERHOME'};
	$DEFAULT_DIR=~s/\/$//;
	}
	else{
	$DEFAULT_DIR='~/SenseLearner';
	}
#'
$srvSock=$options{s};
$own=$options{o};

open $modelFile,"<$DEFAULT_DIR/startedModels.sln" or die "Could not open the $DEFAULT_DIR/startedModels.sln file. Make sure that you have loaded the Timbl servers with the senseLearner -load option\n";
$srvNa=<$modelFile>;
$srvNa=<$modelFile>;
chomp($srvNa);
$srvN=scalar($srvNa);
$i=0;
while (<$modelFile>){
  chomp($_);
  open INFILE,"<$_" or die "could not open word list file $_ \n Most probably you have to repeat the -save process\n";
  while (<INFILE>){
    chomp($_);
    $wordList[$i]{$_}=1;
  }
  print "\n\n size of model $i : ",scalar(keys %{$wordList[$i]}),"\n\n";
  $i++;
  close INFILE;
}
close $modelfile;

print "options: \n s - $srvSock \n o  - $own \n n - $srvN \n ";
my $i;
my @remote;
for ($i=0;$i<$srvN;$i++){
$actPort=$srvSock+$i;
    $temp = IO::Socket::INET->new(
                        Proto    => "tcp",
                        PeerAddr => "127.0.0.1",
                        PeerPort => "$actPort",
                    )
                  or die "cannot connect to daytime port at localhost";
push(@remote,$temp);
$buff=<$temp>;
print "\n ------------------------------------\n server no.: $i ->  $buff \n";
print $temp "c 1 2 3 4 5 6 7 8\n";

$something="";
    while (!($something=~/CATEGORY/) && (!($something=~/ERROR/)) )
	{ $something=<$temp>;
	 print "|$line|\n";
	}
}
print "\n***********************************\n";
print "   Timbl servers are ready!!!\n";
print "***********************************\n";

print "firstone:-> $remote[0] \n second:-> $remote[1]\n\n";

# now starting a server, on the chosen port

$server = IO::Socket::INET->new( Proto     => 'tcp',
                                  LocalPort => $own,
                                  Listen    => SOMAXCONN,
                                  Reuse     => 1);

 die "can't setup server" unless $server;
 print "[buffServer $0 accepting clients]\n";

 while ($client = $server->accept()) {
   $client->autoflush(1);
#   print $client "Welcome to $0; type help for command list.\n";
 #  $hostinfo = gethostbyaddr($client->peeraddr);
 #  printf "[Connect from %s]\n", $hostinfo->name || $client->peerhost;
   print $client "----buffServ at your command---- \n";

   while (    <$client>) {
     next unless /\S/;       # blank line
     if    (/^quit|^exit/i)    { last;                                     }
     elsif (/^c |^classify/i)    # transferring classify command to Timbl;
		{
		@parts = split(/\s+/,);
		$chosenServ=scalar($parts[1]);
		$actWord=$parts[3];
		splice(@parts,1,1);
		$message=join(' ',@parts);
		$temp=$remote[$chosenServ];
		if (defined $wordList[$chosenServ]{$actWord}){
		   print $temp "$message\n";
		   # create a message reading looop
		   $resp="";
		   while (!($resp=~/ERROR/) && !($resp=~/CATEGORY/)){
			$resp=<$temp>;
			print $client "$resp\n";
 		     }
		 }
		 else{
		    #it is a completely unknown word, do not even bother
		     print $client "CATEGORY {xxxComPleteLy_UnknOwn_Wordxxx#1}\n";
		 }
		}
     elsif (/^query/i )         {
		@parts = split(/\s+/,);
		$chosenServ=scalar($parts[1]);
		splice(@parts,1,1);
		$message=join(' ',@parts);
		$temp=$remote[$chosenServ];
		print $temp "$message\n";
		# create a message reading looop
		print "message sent";
		$resp="";
		while ((!($resp=~/ENDSTATUS/)) && (!($resp=~/ERROR/))){
			$resp=<$temp>;
			print $client "$resp\n";
		  }
                }
     else {
       print $client "ERROR unrecognized command\n";
     }
   }
   continue {
   }
   close $client;
 }
